// HTML --> JavaScript
// http://www.accessify.com/tools-and-wizards/developer-tools/html-javascript-convertor/

// sidebar
translations["_load_file"] = {"Czech": "Otevřít GPX/KML/..", "English": "Load GPX/KML/.."};

translations["_load_file_title"] = {"Czech": "Otevře a zobrazí soubor. Podporované formáty: GPX, KML, WPT, PLT + linie/polygony GSAKu a Geogetu.", 
  "English": "Opens and displays a file. Supported formats: GPX, KML, WPT, PLT + GSAK and Geoget lines/polygons."},

translations["_animation"] = {"Czech": "Animace rodiny", "English": "Animate family"},
translations["_labels"] = {"Czech": "Názvy kešek", "English": "Cache labels"},
translations["_circles"] = {"Czech": "Kolizní kruhy 161m", "English": "Collision circles"},
translations["_spider"] = {"Czech": "Spojnice od rodiče", "English": "Lines from parent"},
translations["_scale"] = {"Czech": "Měřítko mapy", "English": "Map scale"},
translations["_overview_map"] = {"Czech": "Náhledová mapa ČR", "English": "Overview map (CZ)"},
translations["_coordinates"] = {"Czech": "Zobrazit souřadnice", "English": "Coordinates window"},
translations["_mark_userflagged_parents"] = {"Czech": "Zvýraznit označené (rodiče)", "English": "Highlight flagged (parents)"},
translations["_mark_userflagged_children"] = {"Czech": "Zvýraznit označené (děti)", "English": "Highlight flagged (children)"},

translations["_animation_title"] = {"Czech": "Po najetí myší na bod animuje všechny body patřící do rodiny. Zkratka: A (jako Animace)", 
  "English": "Animates all points within a family. Shortcut: A (like Animation)"},
translations["_labels_title"] = {"Czech": "Zobrazí na mapě u všech kešek názvy. Lze dočasně vypnout nebo zapnout pomocí SHIFT. Zkratka: Y", 
  "English": "Displays labels of all caches on the map. Can be temporarily (de)activated using SHIFT. Shortcut: Y"},
translations["_circles_title"] = {"Czech": "Zobrazí kolizní kruhy 161 m u všech fyzických bodů (tradiční kešky, finální body a fyzické stage). Zkratka: R (jako Rádius)", 
  "English": "Displays collision circles 161 m (0.1 mile) around all physical caches (Traditional Cache, Final Location, Physical Stage). Shortcut: R (like Radius)"},
translations["_spider_title"] = {"Czech": "Po najetí na bod zobrazí spojnice od rodiče (hlavního bodu kešky) ke všem dětem (child waypointům). Zkratka: L (jako Linie)", 
  "English": "Displays lines from parent to children on hovering over any point in the family. Shortcut: L (like Line)"},
translations["_scale_title"] = {"Czech": "Zobrazí měřítko mapy. Pouze Mapy.cz a ZM10.", 
  "English": "Displays map scale. Only Mapy.cz and ZM10."},
translations["_overview_map_title"] = {"Czech": "Zobrazí neklikatelnou náhledovou mapku ČR. Při zapnutí minimapy je automaticky skrytá.", 
  "English": "Displays unclickable overview map of the Czech Republic. Hidden while minimap is active."},
translations["_coordinates_title"] = {"Czech": "Zobrazí okno se souřadnicemi, na kterých se právě nachází myš.", 
  "English": "Display window with coordinates under the mouse cursor."},
translations["_mark_userflagged_parents_title"] = {"Czech": "Zobrazí červený ovál kolem kešek, které jsou označené v GSAKu (včetně všech jejich dětí).", 
  "English": "Highlights points flagged within GSAK (and all their children) with a red ellipse."},
translations["_mark_userflagged_children_title"] = {"Czech": "Zobrazí žlutý ovál kolem označených Child Waypointů.", 
  "English": "Hightlighs flagged Child Waypoints with a yellow ellipse."},
  
//------------------------  
translations["Hide Children"] = {"Czech": "Skrýt děti"},
translations["Hide Parents"] = {"Czech": "Skrýt rodiče"},
translations["Hide All"] = {"Czech": "Skrýt vše"},
translations["_hide_finals_family"] = {"Czech": "Zobrazit jen finálky", "English": "Show Finals only"},
translations["_private_hide"] = {"Czech": "Speciální mód", "English": "Special mode"},

translations["_hide_children_title"] = {"Czech": "Skryje všechny děti (Child Waypoints). Klávesová zkratka: C (jako Children)", 
  "English": "Hides all Child Waypoints of all caches. Shortcut: C (like Children)"},
  
translations["_hide_parents_title"] = {"Czech": "Skryje všechny rodiče (tedy hlavní body, děti nechá zobrazené). Klávesová zkratka: P (jako Parents)", 
  "English": "Hides all parents (in other words - show only Child Waypoints). Shortcut: P (like Parents)"},
  
translations["_hide_all_title"] = {"Czech": "Skryje úplně všechny keše a všechny jejich body. Pokud při skrytí máte myš na nějaké kešce, takto jediná a všechny její děti zůstanou zobrazeny. Klávesová zkratka: X (jako eXit)", 
  "English": "Hides all caches and their children. When turning this on, if a mouse is over a cache, this one and only cache and its entire family stay displayed. Shortcut: X (like eXit)"},    

translations["_hide_finals_family_title"] = {"Czech": "U bodů, které mají Final Location nebo mají Corrected Coordinates, se zobrazí jen finálka a/nebo Corrected Coordinates.", 
  "English": "Display only Final Location or Corrected Coordinates for each point when that point has either."},

translations["_private_hide_title"] = {"Czech": "Speciální mód. Pokud je keška nalezena, tak to zobrazí jen ty děti, které jsou označené. Pokud keška není nalezena, tak to naopak zobrazí jen ty děti, které nejsou označené. Parkovací body to zobrazí jen pokud jsou explicitně označené (bez ohledu na stav nalezení). Klávesová zkratka: CTRL+ALT+SHIFT+P", 
  "English": "Hides non-flagged children of found caches and flagged children of non-found caches. Parking waypoints are hidden irregardless of found status, unless explicitly flagged. Shortcut: CTRL+ALT+SHIFT+P"},

//------

translations["_hide_status_archived"] = {"Czech": "Skrýt archivované", "English": "Hide archived"},
translations["_hide_status_disabled"] = {"Czech": "Skrýt disablované", "English": "Hide disabled"},
translations["_hide_status_found"] = {"Czech": "Skrýt nalezené", "English": "Hide found"},
translations["_hide_status_owned"] = {"Czech": "Skrýt vlastněné", "English": "Hide owned"},
translations["_hide_status_else"] = {"Czech": "Skrýt ostatní", "English": "Hide other"},
translations["_hide_flagged_parents"] = {"Czech": "Skrýt označené (rodiče)", "English": "Hide flagged (parents)"},
translations["_hide_flagged_children"] = {"Czech": "Skrýt označené (děti)", "English": "Hide flagged (children)"},
translations["_hide_selected"] = {"Czech": "Skrýt vybrané", "English": "Hide selected"},

translations["_hide_status_archived_title"] = {"Czech": "Skryje všechny archivované kešky", "English": "Hides all archived caches"},
translations["_hide_status_disabled_title"] = {"Czech": "Skryje všechny disablované kešky", "English": "Hides all disabled caches"},
translations["_hide_status_found_title"] = {"Czech": "Skryje všechny nalezené kešky", "English": "Hides all found caches"},
translations["_hide_status_owned_title"] = {"Czech": "Skryje všechny vlastněné kešky", "English": "Hides all owned caches"},
translations["_hide_status_else_title"] = {"Czech": "Skryje všechny kešky, které nejsou ani jedno z výše uvedeného (archivované, disablované, nalezené, vlastněné)", "English": "Hides all caches that are not in the list above (archived, disabled, found, owned)"},
translations["_hide_flagged_parents_title"] = {"Czech": "Skryje všechny (v GSAKu) označené rodičovské body (včetně všech jejich dětí).", "English": "Hides all flagged parents (including all their Child Waypoints)."},
translations["_hide_flagged_children_title"] = {"Czech": "Skryje všechny (v GSAKu) označené Child Waypointy.", "English": "Hides all flagged Child Waypoints."},
translations["_hide_selected_title"] = {"Czech": "Skryje vybrané body (více o nich viz Nápověda na pravém tlačítku).", "English": "Hides all selected points (more about them in the Help)."},


//------
translations["Hybrid"] = {"Czech": "Hybrid"},
translations["_relief"] = {"Czech": "Reliéf (ČR / Evropa)", "English": "Relief (Europe)"},
translations["_g_relief"] = {"Czech": "Reliéf (svět)", "English": "Relief"},
translations["Trail"] = {"Czech": "Turistické trasy"},
translations["Bike"] = {"Czech": "Cyklotrasy"},
translations["_land_registry"] = {"Czech": "Katastrální mapa", "English": "Land Registry (CZ)"},
translations["Google Hybrid"] = {"Czech": "Google Hybrid"},
translations["Contour Line"] = {"Czech": "Vrstevnice"},
translations["Ortophoto"] = {"Czech": "Ortofoto"},
translations["Geocaches"] = {"Czech": "Kešky"},

translations["_g_streetview_checkbox_title"] = {"Czech": "Zobrazí vrstvu ukazující dostupnost Street View. Pro zobrazení Street View samotného použijte pravé tlačítko na požadovaném místě.", 
  "English": "Displays Street View availability. For showing actual Street View window, use context menu."},

translations["_katastr_checkbox_title"] = {"Czech": "Pro zobrazení informací o objektu či parcele, klikněte na dané místo pravým tlačítkem a pak použijte volbu 'Otevřít stránku v katastru'.", 
  "English": "Works only within the Czech Republic. For showing extended information about a place, use context menu."},

translations["_geocaches_checkbox_title"] = {"Czech": "Kešky nejsou klikatelné!", 
  "English": "Caches are not clickable!"},

//------  
translations["Cache Filter"] = {"Czech": "WP Filtr"},
translations["_show_all"] = {"Czech": "Zobrazit vše", "English": "Show all"},
translations["_hide_all"] = {"Czech": "Skrýt vše", "English": "Hide all"},

//------------------------  

(function(){
  function runLI(target)
  {
    // get LI
    if (target.parentNode.tagName.toLowerCase() == "li")
      target = target.parentNode;
    
    // filter out non-LI elements or empty LI (separator)  
    if (target.tagName.toLowerCase() != "li" || !target.firstChild)
      return;
    
    if (target.id == "refresh_button")
    {
      window.location.href = "gsak://%FF/macro:silent/HTML_Custom_MapyCZ.gsk";
      //window.location.href = "gsak://%FF/macro:silent/HTML_Custom_MapyCZ\\Update_Database.gsk?refresh/" + cachecode;
      //window.location.href = "gsak://%FF/refreshbrowser";
      return;
    }
    
    if (target.id == "load_file_button")
    {
      loadFile("fileInput2", target);
      return;
    }    

    if (target.firstChild.tagName.toLowerCase() == "input" && target.firstChild.type == "checkbox")
    {
      toggleSetting(target.firstChild.id.match(/^(\w+)_checkbox/)[1], "toggle");

      // send signal
      m.getSignals().makeEvent("sidebar-checkbox-change");
    } 
  }

  //########################################################################################
  // menu sidebar

  var menu_sidebar_html="";
  menu_sidebar_html += "<div class=\"sidebar\" id=\"map_sidebar\" style=\"display: none\">";

  menu_sidebar_html += "  <div class=\"sidebar_checkboxes\">";
  
  if (!window.OpenInBrowser)
    menu_sidebar_html += "    <li class=\"button GSAK_Only\" id=\"refresh_button\">" + tr("Refresh") + "<\/li>";

  menu_sidebar_html += "    <li class=\"button\" id=\"load_file_button\" title=\"" + tr("_load_file_title") + "\">" + tr("_load_file") + "<\/li>";      
  menu_sidebar_html += "    <li class=\"li_separator\"><\/li>";
  menu_sidebar_html += "    <li id=\"li_animation\" title=\"" + tr("_animation_title") + "\"><input type=\"checkbox\" id=\"animation_checkbox\"><span>" + tr("_animation") + "<\/span><\/li>";
  menu_sidebar_html += "    <li title=\"" + tr("_labels_title") + "\"><input type=\"checkbox\" id=\"bubble_checkbox\"><span>" + tr("_labels") + "<\/span><\/li>";
  menu_sidebar_html += "    <li title=\"" + tr("_circles_title") + "\"><input type=\"checkbox\" id=\"circles_checkbox\"><span>" + tr("_circles") + "<\/span><\/li>";
  menu_sidebar_html += "    <li title=\"" + tr("_spider_title") + "\"><input type=\"checkbox\" id=\"spider_checkbox\"><span>" + tr("_spider") + "<\/span><\/li>";
  
  menu_sidebar_html += "    <li class=\"GSAK_Only\" title=\"" + tr("_mark_userflagged_parents_title") + "\"><input type=\"checkbox\" id=\"mark_userflagged_parents_checkbox\"><span>" + tr("_mark_userflagged_parents") + "<\/span><\/li>";
  menu_sidebar_html += "    <li class=\"GSAK_Only\" title=\"" + tr("_mark_userflagged_children_title") + "\"><input type=\"checkbox\" id=\"mark_userflagged_children_checkbox\"><span>" + tr("_mark_userflagged_children") + "<\/span><\/li>";
       
  menu_sidebar_html += "    <li title=\"" + tr("_scale_title") + "\"><input type=\"checkbox\" id=\"scale_checkbox\"><span>" + tr("_scale") + "<\/span><\/li>";
  menu_sidebar_html += "    <li title=\"" + tr("_overview_map_title") + "\"><input type=\"checkbox\" id=\"overview_map_checkbox\"><span>" + tr("_overview_map") + "<\/span><\/li>";
  menu_sidebar_html += "    <li title=\"" + tr("_coordinates_title") + "\"><input type=\"checkbox\" id=\"coordinates_box_checkbox\"><span>" + tr("_coordinates") + "<\/span><\/li>";

  if (!window.SplitScreen)
  {
    menu_sidebar_html += "  <\/div>";
    menu_sidebar_html += "  <div class=\"sidebar_checkboxes\" style=\"border-left: 2px solid black; border-radius: 0px;\">";
  }
  else
  {
    menu_sidebar_html += "    <li class=\"li_separator\"><\/li>";
  }
  
  menu_sidebar_html += "    <li><input type=\"checkbox\" id=\"trail_checkbox\"><span>" + tr("Trail") + "<\/span><\/li>";
  menu_sidebar_html += "    <li><input type=\"checkbox\" id=\"bike_checkbox\"><span>" + tr("Bike") + "<\/span><\/li>";
  //menu_sidebar_html += "    <li><input type=\"checkbox\" id=\"amapy_tur_checkbox\"><span>" + tr("Trail") + "<\/span><\/li>";  
  //menu_sidebar_html += "    <li><input type=\"checkbox\" id=\"amapy_cyklo_checkbox\"><span>" + tr("Bike") + "<\/span><\/li>";
  menu_sidebar_html += "    <li><input type=\"checkbox\" id=\"relief_checkbox\"><span>" + tr("_relief") + "<\/span><\/li>";
  menu_sidebar_html += "    <li><input type=\"checkbox\" id=\"g_terrain_checkbox\"><span>" + tr("_g_relief") + "<\/span><\/li>";
  menu_sidebar_html += "    <li><input type=\"checkbox\" id=\"vrstevnice_checkbox\"><span>" + tr("Contour Line") + "<\/span><\/li>";
  menu_sidebar_html += "    <li><input type=\"checkbox\" id=\"hybrid_checkbox\"><span>" + tr("Hybrid") + "<\/span><\/li>";
  menu_sidebar_html += "    <li><input type=\"checkbox\" id=\"g_hybrid_checkbox\"><span>" + tr("Google Hybrid") + "<\/span><\/li>";
  menu_sidebar_html += "    <li><input type=\"checkbox\" id=\"ortofoto_checkbox\"><span>" + tr("Ortophoto") + "<\/span><\/li>";
  menu_sidebar_html += "    <li><input type=\"checkbox\" id=\"g_ortofoto_checkbox\"><span>" + tr("Ortophoto") + "<\/span><\/li>";
  menu_sidebar_html += "    <li title=\"" + tr("_g_streetview_checkbox_title") + "\"><input type=\"checkbox\" id=\"g_streetview_checkbox\"><span>" + tr("Street View") + "<\/span><\/li>";
  menu_sidebar_html += "    <li title=\"" + tr("_katastr_checkbox_title") + "\"><input type=\"checkbox\" id=\"katastr_checkbox\"><span>" + tr("_land_registry") + "<\/span><\/li>";
  menu_sidebar_html += "    <li title=\"" + tr("_geocaches_checkbox_title") + "\"><input type=\"checkbox\" id=\"geocaches_checkbox\"><span>" + tr("Geocaches") + "<\/span><\/li>";
  menu_sidebar_html += "  <\/div>";

  menu_sidebar_html += "<\/div>";

  var menu_sidebar = document.createElement("div");
  menu_sidebar.innerHTML = menu_sidebar_html;
  menu_sidebar = menu_sidebar.firstChild;
  
  // turn off right border for rightmost div
  menu_sidebar.lastChild.style.borderRight = "none";
    
  //var menu_sidebar = document.getElementById("map_sidebar");
  
  var menuSidebarInit = false;

  /**** left click on button - show sidebar ****/
  EventUtil.addHandler(sidebar_button, "click", function()
  {
    if (!menuSidebarInit)
    {
      sidebars_div.appendChild(menu_sidebar);
      
      // set checkboxes
      document.getElementById("animation_checkbox").checked = settings.display_animation;
      document.getElementById("bubble_checkbox").checked = contains_class(mapadiv, "marker_bubble");
      document.getElementById("circles_checkbox").checked = settings.display_circles;
      document.getElementById("spider_checkbox").checked = settings.display_spider;
      
      document.getElementById("mark_userflagged_parents_checkbox").checked = settings.display_mark_userflagged_parents;
      document.getElementById("mark_userflagged_children_checkbox").checked = settings.display_mark_userflagged_children;
      
      // scale
      var scaleCheckbox = document.getElementById("scale_checkbox");
      scaleCheckbox.checked = settings.display_scale;

      // coordinates box
      var coordinatesBoxCheckbox = document.getElementById("coordinates_box_checkbox");
      coordinatesBoxCheckbox.checked = settings.display_coordinates_box;

      // overview map
      var overviewMapCheckbox = document.getElementById("overview_map_checkbox");
      overviewMapCheckbox.checked = settings.display_overview_map;
      
      // transparent layers
      for (transp in transparentLayers)
      {
        var val = settings.transparent_layers[settings.map][transp];
        var checkbox = document.getElementById(transp + "_checkbox");
        checkbox.parentNode.style.display = (typeof val === 'undefined') ? "none" : "";
        checkbox.checked = val;
      }

      // turn off non-transparent sub-layers for IE <= 8
      if (JAK.Browser.client == "ie" && JAK.Browser.version <= 8)
      {
        document.getElementById("ortofoto_checkbox").parentNode.style.display = "none";
        document.getElementById("g_ortofoto_checkbox").parentNode.style.display = "none";
      }  
      
      menuSidebarInit = true;
    }

    // show / hide sidebar
    menu_sidebar.style.display = "block";
  });

  /**** mouseout - hide sidebar ****/
  EventUtil.addMouseHandler(menu_sidebar, "mouseleave", function(e, target)
  {
    menu_sidebar.style.display = "";
  });    

  /**** left click on sidebar ****/
  EventUtil.addHandler(menu_sidebar, "click", function(e, target)
  {
    var origTarget = target;
    
    // --- handle left menu ---
    runLI(target);
  });

  //########################################################################################
  // filder sidebar

  var filter_siderbar_html="";
  filter_siderbar_html += "<div class=\"sidebar\" id=\"filter_sidebar\" style=\"display: none\">";
  filter_siderbar_html += "  <ul class=\"sidebar_checkboxes\">";
  filter_siderbar_html += "    <li title=\"" + tr("_hide_children_title") + "\"><input type=\"checkbox\" id=\"hide_children_checkbox\"><span>" + tr("Hide Children") + "<\/span><\/li>";
  filter_siderbar_html += "    <li title=\"" + tr("_hide_parents_title") + "\"><input type=\"checkbox\" id=\"hide_parents_checkbox\"><span>" + tr("Hide Parents") + "<\/span><\/li>";
  filter_siderbar_html += "    <li title=\"" + tr("_hide_all_title") + "\"><input type=\"checkbox\" id=\"hide_checkbox\"><span>" + tr("Hide All") + "<\/span><\/li>";
  filter_siderbar_html += "    <li title=\"" + tr("_hide_finals_family_title") + "\"><input type=\"checkbox\" id=\"hide_finals_family_checkbox\"><span>" + tr("_hide_finals_family") + "<\/span><\/li>";
  filter_siderbar_html += "    <li class=\"GSAK_Only\" title=\"" + tr("_private_hide_title") + "\"><input type=\"checkbox\" id=\"private_hide_checkbox\"><span>" + tr("_private_hide") + "<\/span><\/li>";
  
  filter_siderbar_html += "    <li class=\"li_separator\"><\/li>";

  filter_siderbar_html += "    <li title=\"" + tr("_hide_status_archived_title") + "\"><input type=\"checkbox\" id=\"hide_status_archived_checkbox\"><span>" + tr("_hide_status_archived") + "<\/span><\/li>";
  filter_siderbar_html += "    <li title=\"" + tr("_hide_status_disabled_title") + "\"><input type=\"checkbox\" id=\"hide_status_disabled_checkbox\"><span>" + tr("_hide_status_disabled") + "<\/span><\/li>";
  filter_siderbar_html += "    <li title=\"" + tr("_hide_status_found_title") + "\"><input type=\"checkbox\" id=\"hide_status_found_checkbox\"><span>" + tr("_hide_status_found") + "<\/span><\/li>";
  filter_siderbar_html += "    <li title=\"" + tr("_hide_status_owned_title") + "\"><input type=\"checkbox\" id=\"hide_status_owned_checkbox\"><span>" + tr("_hide_status_owned") + "<\/span><\/li>";
  filter_siderbar_html += "    <li title=\"" + tr("_hide_status_else_title") + "\"><input type=\"checkbox\" id=\"hide_status_else_checkbox\"><span>" + tr("_hide_status_else") + "<\/span><\/li>";
  
  filter_siderbar_html += "    <li class=\"li_separator\"><\/li>";

  filter_siderbar_html += "    <li class=\"GSAK_Only\" title=\"" + tr("_hide_flagged_parents_title") + "\"><input type=\"checkbox\" id=\"hide_flagged_parents_checkbox\"><span>" + tr("_hide_flagged_parents") + "<\/span><\/li>";
  filter_siderbar_html += "    <li class=\"GSAK_Only\" title=\"" + tr("_hide_flagged_children_title") + "\"><input type=\"checkbox\" id=\"hide_flagged_children_checkbox\"><span>" + tr("_hide_flagged_children") + "<\/span><\/li>";
  filter_siderbar_html += "    <li title=\"" + tr("_hide_selected_title") + "\"><input type=\"checkbox\" id=\"hide_selected_checkbox\"><span>" + tr("_hide_selected") + "<\/span><\/li>";

  filter_siderbar_html += "  <\/ul>";
  filter_siderbar_html += "";
  filter_siderbar_html += "  <div id=\"sidebar_cache_filter\">";
  filter_siderbar_html += "";
  filter_siderbar_html += "    <div id=\"cache_filter_header\">";
  filter_siderbar_html += "      <div id=\"cache_filter_label\">" + tr("Cache Filter") + "<\/div>";
  filter_siderbar_html += "      <div id=\"cache_filter_buttons\">";
  filter_siderbar_html += "        <div class=\"button\" id=\"cache_filter_show_all\">" + tr("_show_all") + "<\/div>";
  filter_siderbar_html += "        <div class=\"button\" id=\"cache_filter_hide_all\">" + tr("_hide_all") + "<\/div>";
  filter_siderbar_html += "      <\/div>";
  filter_siderbar_html += "    <\/div>";
  filter_siderbar_html += "";
  filter_siderbar_html += "    <div id=\"cache_filter_parents\">";
  filter_siderbar_html += "      <div class=\"cacheimg_parent cacheimg_T\" data-cachetype=\"T\"><\/div>";
  filter_siderbar_html += "      <div class=\"cacheimg_parent cacheimg_M\" data-cachetype=\"M\"><\/div>";
  filter_siderbar_html += "      <div class=\"cacheimg_parent cacheimg_U\" data-cachetype=\"U\"><\/div>";
  filter_siderbar_html += "      <div class=\"cacheimg_parent cacheimg_B\" data-cachetype=\"B\"><\/div>";
  filter_siderbar_html += "      <div class=\"cacheimg_parent cacheimg_R\" data-cachetype=\"R\"><\/div>";
  filter_siderbar_html += "      <div class=\"cacheimg_parent cacheimg_I\" data-cachetype=\"I\"><\/div>";
  filter_siderbar_html += "      <div class=\"clear_both\"><\/div>";
  filter_siderbar_html += "      <div class=\"cacheimg_parent cacheimg_Y\" data-cachetype=\"Y\"><\/div>";
  filter_siderbar_html += "      <div class=\"cacheimg_parent cacheimg_W\" data-cachetype=\"W\"><\/div>";
  filter_siderbar_html += "      <div class=\"cacheimg_parent cacheimg_V\" data-cachetype=\"V\"><\/div>";
  filter_siderbar_html += "      <div class=\"cacheimg_parent cacheimg_E\" data-cachetype=\"E\"><\/div>";
  filter_siderbar_html += "      <div class=\"cacheimg_parent cacheimg_Z\" data-cachetype=\"Z\"><\/div>";
  filter_siderbar_html += "      <div class=\"cacheimg_parent cacheimg_C\" data-cachetype=\"C\"><\/div>";
  filter_siderbar_html += "      <div class=\"clear_both\"><\/div>";
  filter_siderbar_html += "      <div class=\"cacheimg_parent cacheimg_L\" data-cachetype=\"L\"><\/div>";
  filter_siderbar_html += "      <div class=\"cacheimg_parent cacheimg_O\" data-cachetype=\"O\"><\/div>";
  filter_siderbar_html += "      <div class=\"cacheimg_parent cacheimg_A\" data-cachetype=\"A\"><\/div>";
  filter_siderbar_html += "      <div class=\"cacheimg_parent cacheimg_G\" data-cachetype=\"G\"><\/div>";
  filter_siderbar_html += "      <div class=\"cacheimg_parent cacheimg_X\" data-cachetype=\"X\"><\/div>";
  filter_siderbar_html += "      <div class=\"cacheimg_parent cacheimg_F\" data-cachetype=\"F\"><\/div>";
  filter_siderbar_html += "      <div class=\"clear_both\"><\/div>";
  filter_siderbar_html += "      <div class=\"cacheimg_parent cacheimg_H\" data-cachetype=\"H\"><\/div>";
  filter_siderbar_html += "      <div class=\"cacheimg_parent cacheimg_D\" data-cachetype=\"D\"><\/div>";
  filter_siderbar_html += "      <div class=\"cacheimg_parent cacheimg_P\" data-cachetype=\"P\"><\/div>";
  filter_siderbar_html += "      <div class=\"cacheimg_parent cacheimg_J\" data-cachetype=\"J\"><\/div>";  
  filter_siderbar_html += "      <div class=\"clear_both\"><\/div>";
  filter_siderbar_html += "    <\/div>";
  filter_siderbar_html += "    ";
  filter_siderbar_html += "    <div id=\"cache_filter_children\">";
  filter_siderbar_html += "      <div class=\"cacheimg_child cacheimg_FinalLocation\" data-cachetype=\"FinalLocation\"><\/div>";
  filter_siderbar_html += "      <div class=\"cacheimg_child cacheimg_ParkingArea\" data-cachetype=\"ParkingArea\"><\/div>";
  filter_siderbar_html += "      <div class=\"cacheimg_child cacheimg_VirtualStage\" data-cachetype=\"VirtualStage\"><\/div>";
  filter_siderbar_html += "      <div class=\"cacheimg_child cacheimg_PhysicalStage\" data-cachetype=\"PhysicalStage\"><\/div>";
  filter_siderbar_html += "      <div class=\"cacheimg_child cacheimg_Trailhead\" data-cachetype=\"Trailhead\"><\/div>";
  filter_siderbar_html += "      <div class=\"cacheimg_child cacheimg_ReferencePoint\" data-cachetype=\"ReferencePoint\"><\/div>";
  filter_siderbar_html += "      <div class=\"cacheimg_child cacheimg_Corrected\" data-cachetype=\"Corrected\"><\/div>";
  filter_siderbar_html += "    <\/div>";
  filter_siderbar_html += "  <\/div>";
  filter_siderbar_html += "<\/div>";
  
  // <div class="sidebar" id="filter_sidebar" style="display: none">
  //   <ul class="sidebar_checkboxes">
  //     <li><input type="checkbox" id="hide_children_checkbox"><span data-tr>Hide Children</span></li>
  //     <li><input type="checkbox" id="hide_parents_checkbox"><span data-tr>Hide Parents</span></li>
  //     <li><input type="checkbox" id="hide_checkbox"><span data-tr>Hide All</span></li>
  //   </ul>
  // 
  //   <div id="sidebar_cache_filter">
  // 
  //     <div id="cache_filter_header">
  //       <div id="cache_filter_label" data-tr>Cache Filter</div>
  //       <div id="cache_filter_buttons">
  //         <div class="button" id="cache_filter_show_all" data-tr>_show_all</div>
  //         <div class="button" id="cache_filter_hide_all" data-tr>_hide_all</div>
  //       </div>
  //     </div>
  // 
  //     <div id="cache_filter_parents">
  //       <div class="cacheimg_parent cacheimg_T" data-cachetype="T"></div>
  //       <div class="cacheimg_parent cacheimg_M" data-cachetype="M"></div>
  //       <div class="cacheimg_parent cacheimg_U" data-cachetype="U"></div>
  //       <div class="cacheimg_parent cacheimg_B" data-cachetype="B"></div>
  //       <div class="cacheimg_parent cacheimg_R" data-cachetype="R"></div>
  //       <div class="cacheimg_parent cacheimg_I" data-cachetype="I"></div>
  //       <div class="clear_both"></div>
  //       <div class="cacheimg_parent cacheimg_Y" data-cachetype="Y"></div>
  //       <div class="cacheimg_parent cacheimg_W" data-cachetype="W"></div>
  //       <div class="cacheimg_parent cacheimg_V" data-cachetype="V"></div>
  //       <div class="cacheimg_parent cacheimg_E" data-cachetype="E"></div>
  //       <div class="cacheimg_parent cacheimg_Z" data-cachetype="Z"></div>
  //       <div class="cacheimg_parent cacheimg_C" data-cachetype="C"></div>
  //       <div class="clear_both"></div>
  //       <div class="cacheimg_parent cacheimg_L" data-cachetype="L"></div>
  //       <div class="cacheimg_parent cacheimg_O" data-cachetype="O"></div>
  //       <div class="cacheimg_parent cacheimg_A" data-cachetype="A"></div>
  //       <div class="cacheimg_parent cacheimg_G" data-cachetype="G"></div>
  //       <div class="cacheimg_parent cacheimg_X" data-cachetype="X"></div>
  //       <div class="cacheimg_parent cacheimg_F" data-cachetype="F"></div>
  //       <div class="clear_both"></div>
  //       <div class="cacheimg_parent cacheimg_H" data-cachetype="H"></div>
  //       <div class="cacheimg_parent cacheimg_D" data-cachetype="D"></div>
  //       <div class="cacheimg_parent cacheimg_P" data-cachetype="P"></div>
  //       <div class="cacheimg_parent cacheimg_J" data-cachetype="J"></div>  
  //       <div class="clear_both"></div>
  //     </div>
  //     
  //     <div id="cache_filter_children">
  //       <div class="cacheimg_child cacheimg_FinalLocation" data-cachetype="FinalLocation"></div>
  //       <div class="cacheimg_child cacheimg_ParkingArea" data-cachetype="ParkingArea"></div>
  //       <div class="cacheimg_child cacheimg_VirtualStage" data-cachetype="VirtualStage"></div>
  //       <div class="cacheimg_child cacheimg_PhysicalStage" data-cachetype="PhysicalStage"></div>
  //       <div class="cacheimg_child cacheimg_Trailhead" data-cachetype="Trailhead"></div>
  //       <div class="cacheimg_child cacheimg_ReferencePoint" data-cachetype="ReferencePoint"></div>
  //       <div class="cacheimg_child cacheimg_Corrected" data-cachetype="Corrected"></div>
  //     </div>
  //   </div>
  // </div> 
  
  var filter_sidebar = document.createElement("div");
  filter_sidebar.innerHTML = filter_siderbar_html;
  filter_sidebar = filter_sidebar.firstChild;  
  //var filter_sidebar = document.getElementById("filter_sidebar");

  var filterSidebarInit = false;
  
  /**** left click on button - show sidebar ****/
  EventUtil.addHandler(filter_button, "click", function()
  {
    if (!filterSidebarInit)
    {
      sidebars_div.appendChild(filter_sidebar);
      
      // set checkboxes
      document.getElementById("hide_children_checkbox").checked = settings["hide_children_local"];
      document.getElementById("hide_parents_checkbox").checked = settings["hide_parents_local"];
      document.getElementById("hide_checkbox").checked = contains_class(mapadiv, "marker_hide");
      document.getElementById("hide_finals_family_checkbox").checked = settings["hide_finals_family"];
      document.getElementById("private_hide_checkbox").checked =  settings["private_hide"];
      document.getElementById("hide_status_archived_checkbox").checked = settings["hide_status_archived"];
      document.getElementById("hide_status_disabled_checkbox").checked = settings["hide_status_disabled"];
      document.getElementById("hide_status_found_checkbox").checked = settings["hide_status_found"];
      document.getElementById("hide_status_owned_checkbox").checked = settings["hide_status_owned"];
      document.getElementById("hide_status_else_checkbox").checked = settings["hide_status_else"];
      
      document.getElementById("hide_flagged_parents_checkbox").checked = settings["hide_flagged_parents"];
      document.getElementById("hide_flagged_children_checkbox").checked = settings["hide_flagged_children"];
      document.getElementById("hide_selected_checkbox").checked = settings["hide_selected"];

      /**** init cache filter with caches that are present ****/
      var nodes = document.querySelectorAll("#sidebar_cache_filter .cacheimg_parent, #sidebar_cache_filter .cacheimg_child");
      
      // get available cache types
      var cachetypes = {};
      
      for (var i in wp)
        cachetypes[wp[i].CacheType] = true;
            
      // parse and set sidebar DIVs (cache icons)
      for (var i = 0, len = nodes.length; i < len; i++)
      {
        var cachetype = nodes[i].getAttribute("data-cachetype");
        nodes[i].title = CacheNames[cachetype];
        add_class(nodes[i], cachetypes[cachetype] ? "active" : "disabled");
      }
      
      filterSidebarInit = true;    
    }
  
    // show / hide sidebar
    filter_sidebar.style.display = "block";
  });

  /**** mouseout - hide sidebar ****/
  EventUtil.addMouseHandler(filter_sidebar, "mouseleave", function(e, target)
  {
    filter_sidebar.style.display = "";
  });
  
  /**** left click on sidebar ****/
  EventUtil.addHandler(filter_sidebar, "click", function(e, target)
  {
    var origTarget = target;
    
    // --- handle cache filter ---
    
    // handle click on cache icon
    var cachetype = target.getAttribute("data-cachetype");
    
    if (cachetype)
    {
      if (contains_class(target, "active")) 
        toggleSetting("disable_cache", target);
      else if (contains_class(target, "inactive")) 
        toggleSetting("enable_cache", target);
      else                                          
        return;
    }
    
    // handle show/hide all buttons
    if (target.id == "cache_filter_show_all" || target.id == "cache_filter_hide_all")
    {
      var nodes = document.querySelectorAll("#sidebar_cache_filter .cacheimg_parent, #sidebar_cache_filter .cacheimg_child");

      for (var i = 0, len = nodes.length; i < len; i++)
      {
        if (contains_class(nodes[i], "disabled"))
          continue;

        toggleSetting((target.id == "cache_filter_show_all") ? "enable_cache" : "disable_cache", nodes[i]);
      }    
    }
    
    // --- handle left menu ---
    runLI(target);
  });
})();  